#include "Datenbank.h"
#include <iostream>

namespace {
// SQL-Zahlen auf 2 dargestellte Nachkommazahlen bringen
std::string formatPreis(const std::string& s)
{
  auto punkt{s.find('.')};
  if (punkt == std::string::npos) {
    return s + ".00";
  }
  else if (s.length() - punkt == 2) {
    return s + "0";
  }
  return s;
}
}          // namespace

int main()
{
  try {
    Datenbank db("shopdb.db");
    enum Rechnungen {NR, DATUM, NAME, PLZ, ORT, STRNR, MENGE, ARTNR, 
                     BEZ, EPREIS, GPREIS};
    auto rechnungen = db.execute("select * from alles");
    std::string rechnNr("");
    int z{0};
    bool rechnungskopfGedruckt{false};
    int position{0};
    while ( z < ssize(rechnungen)) {
      if (rechnNr != rechnungen[z][NR]) {          // neue Rechnung beginnt
        rechnNr = rechnungen[z][NR];
        rechnungskopfGedruckt = false;
      }
      if (rechnungen[z][NAME] != "") {       // Kunde existiert, kein Barverkauf
        if (!rechnungskopfGedruckt) {
          std::cout << "Herrn/Frau/Firma " << rechnungen[z][NAME] << '\n'
                    << rechnungen[z][STRNR] << '\n'
                    << rechnungen[z][PLZ] << " " << rechnungen[z][ORT] 
                    << "\n\n\nRechnung Nr. "     << rechnNr 
                    << "  vom " << rechnungen[z][DATUM]
                    << "\nPos. Menge   Artikelnr.        Bezeichnung "
            "Einzelpreis Gesamtpreis\n";
          rechnungskopfGedruckt = true;
          position = 1;
        }
        // Positionen ausgeben
        std::cout.width(4);
        std::cout << position++;
        std::cout.width(6);
        std::cout << rechnungen[z][MENGE];
        std::cout.width(12);
        std::cout << rechnungen[z][ARTNR];
        std::cout.width(20);
        std::cout << rechnungen[z][BEZ];
        std::cout.width(12);
        std::cout << formatPreis(rechnungen[z][EPREIS]);
        std::cout.width(12);
        std::cout << formatPreis(rechnungen[z][GPREIS]) << '\n';
      }
      ++z;
      if (rechnungskopfGedruckt && (z == ssize(rechnungen) ||
                                    (z < ssize(rechnungen)
                                      && rechnNr != rechnungen[z][NR]))) {
        auto summe = db.execute("select sum(Preis*Menge) from alles where "
                                "Rechnungsnr=" + rechnNr + ";");
        std::cout.width(66);
        std::cout << "-----------\n";
        std::cout.width(66);
        std::cout << formatPreis(summe[0][0]) << "\n\f\n";       // Seitenvorschub
      }
    }
  }
  catch (const std::exception& e) {
    std::cerr << e.what() << '\n';
  }
}
