#include <Random.h>
#include <algorithm>
#include <cmath>
#include <showContainer.h>
#include <vector>

bool intVergleich(double x, double y)
{ 
  // trunc() gibt den Wert nach Abschneiden (engl. truncate)
  // der Nachkommastellen zurück.
  return std::trunc(x) < std::trunc(y); 
}
using namespace std;

int main()
{
  vector<double> v(17);
  Random zufallg(v.size() / 3);              // ganzzahliger Anteil, siehe unten
  Random zufallRest(1000);
  // Vektor mit Zufallswerten initialisieren. Dabei sollen einige Werte denselben ganzzahligen
  // Anteil haben, um den Unterschied von stabiler und nicht-stabiler Sortierung sehen zu können.
  for (auto& wert : v) {
    wert = zufallg() + double(zufallRest() / 1000.0);
  }
  vector<double> unstable = v;               // Hilfsvektoren
  vector<double> stable = v;
  cout << "Vektor             :\n";
  showContainer(v);

  // Sortierung mit < Operator:
  cout << "Kein Unterschied, weil double-Zahlen als Key genommen werden\n"
          "stabile Sortierung   :\n";
  ranges::stable_sort(stable);
  showContainer(stable);

  cout << "unstabile Sortierung :\n";
  ranges::sort(unstable);
  showContainer(unstable);

  //  Sortierung mit Funktion statt <
  unstable = v;
  stable = v;
  cout << "Unterschied, weil nur der int-Teil Sortierkriterium ist\n";

  cout << "stabile Sortierung (int-Kriterium)  :\n";
  ranges::stable_sort(stable, intVergleich);
  showContainer(stable);

  cout << "unstabile Sortierung (int-Kriterium)  :\n";
  ranges::sort(unstable, intVergleich);
  showContainer(unstable);
}

