#include "../../strings/split.h"
#include <iostream>
#include <regex>

bool ip4ok(const std::string& eingabe)
{
  std::regex datumregex("(?:\\d\\d?\\d?\\.){3}\\d\\d?\\d?");
  bool ergebnis = std::regex_match(eingabe, datumregex);
  if (ergebnis) {          // Syntax ok, Inhalt prüfen
    auto v = split(eingabe, ".");
    for (int i = 0; i < ssize(v); ++i) {
      ergebnis = ergebnis && std::stoi(v[i]) < 256;
    }
  }
  return ergebnis;
}

using namespace std;

int main(int argc, char* argv[])
{
  if (2 != argc) {
    cout << "Gebrauch: " << argv[0] << " \"IP-Adresse, z.B. 127.0.0.1\"\n";
  }
  else {
    try {
      if (ip4ok(argv[1])) {
        cout << argv[1] << " ist eine gültige IP-Adresse.\n";
      }
      else {
        cout << argv[1] << " ist keine gültige IP-Adresse.\n";
      }
    }
    catch (regex_error& re) {
      cerr << "Fehler: " << re.what() << '\n';
    }
  }
}
