#include "Kreis.h"
#include <iostream>
#include <limits>

int main()
{
  constexpr Kreis ck(100.0);                // const und constexpr
  constexpr auto cr  = ck.getRadius();
  constexpr auto cf = ck.getFlaeche();
  std::cout << "Radius = " << cr << ". Fläche =  " << cf << '\n';

  const Kreis k(10.0);                      //  const, aber nicht constexpr
  const auto r = k.getRadius();
  const auto f = k.getFlaeche();
  std::cout << "Radius = " << r << ". Fläche =  " << f << '\n';

  Kreis k1(210.0);                          // nicht const
  k1.setRadius(9.07);                       // constexpr spielt keine Rolle
  std::cout << "Radius = " << k1.getRadius()
            << ". Fläche =  " << k1.getFlaeche() << '\n';

  constexpr auto skaliert = skalieren(ck, 0.5);   // const und constexpr
  std::cout << "Radius = " << skaliert.getRadius()
            << ". Fläche =  " << skaliert.getFlaeche() << '\n';

  const auto skaliert1 = skalieren(k, 0.5); //  const, aber nicht constexpr
  std::cout << "Radius = " << skaliert1.getRadius()
            << ". Fläche =  " << skaliert1.getFlaeche() << '\n';
}

