#ifndef SIMPLESTACK1_T
#define SIMPLESTACK1_T
#include <cassert>

template <typename T>
class SimpleStack1 {
public:
  static const int maxSize {20};             // siehe Text
  // inline definierte Methoden
  bool empty() const { return anzahl == 0; }
  bool full() const  { return anzahl == maxSize; }
  auto size() const  { return anzahl; }
  void clear()       { anzahl = 0; }         // Stack leeren
  // Methoden, deren Implementation unten folgt:
  const T& top() const;                      // letztes Element sehen
  void pop();                                // Element entfernen
  // Vorbedingung für top und pop: Stack ist nicht leer
  void push(const T& x);                     // x auf den Stack legen
  // Vorbedingung für push: Stack ist nicht voll
private:
  int anzahl{0};                             // Anfangswert
  T array[maxSize];                          // Behälter für Elemente
};
// noch fehlende Methoden-Implementierungen als Alternative zur inline-Definition
template <typename T>
const T& SimpleStack1<T>::top() const
{
  assert(!empty());
  return array[anzahl - 1];
}

template <typename T>
void SimpleStack1<T>::pop()
{
  assert(!empty());
  --anzahl;
}

template <typename T>
void SimpleStack1<T>::push(const T& x)
{
  assert(!full());
  array[anzahl++] = x;
}
#endif
