#ifndef STRINGANSICHT_H
#define STRINGANSICHT_H
#include <cassert>
#include <iostream>                         // ostream
#include <string>

class StringAnsicht {
public:
  explicit constexpr StringAnsicht(const char* str = "") 
    : zeiger(str), laenge(std::char_traits<char>::length(str))
  {  }

  constexpr auto at(int position) const
  {
    assert(position < laenge);
    return zeiger[position];
  }

  constexpr auto length() const { return laenge; }
  constexpr auto data()   const { return zeiger; }
  constexpr auto begin()  const { return zeiger; }
  constexpr auto end()    const { return zeiger + laenge; }
private:
  const char* zeiger;
  int laenge;
};

inline void anzeigen(std::ostream& os, StringAnsicht m)
{ 
  os << m.data(); 
}
#endif

