#include <iostream>
#include <typeinfo>
#define PRINT(X) std::cout << (#X) << " = " << std::boolalpha << (X) << '\n'

class Basis {
public:
  virtual ~Basis() = default;               // für polymorphe Klasse sorgen
  Basis() = default;
  Basis(const Basis&) = delete;
  Basis& operator=(const Basis&) = delete;
};

class Abgeleitet : public Basis {
};

int main()
{
  Abgeleitet Objekt1;
  Abgeleitet Objekt2;
  Basis* p = &Objekt1;
  std::cout << "compilerabhängiger Klassenname: "
            << typeid(Objekt1).name() << '\n';

  PRINT(typeid(Objekt2) == typeid(*p));     // *p ist polymorph

  Basis einBasisObjekt;
  std::cout  << "compilerabhängiger Klassenname: "
             << typeid(einBasisObjekt).name() << '\n';
  PRINT(typeid(Objekt1) == typeid(einBasisObjekt));

  std::cout << "\nException mit nullptr provozieren!" << std::endl;
  Basis* pNull = nullptr;
  PRINT(typeid(Objekt1) == typeid(*pNull)); // Exception
}

