// noch nicht vollständig! (s. Übungsaufgaben)
#ifndef DATUM_H
#define DATUM_H
#include <stdexcept>
#include <string>

class UngueltigesDatumException : public std::runtime_error {
public:
  UngueltigesDatumException(int t, int m, int j)
      : std::runtime_error(toString(t, m, j))
  { }

private:
  static std::string toString(int tag, int monat, int jahr)
  {
    std::string meldung = std::to_string(tag) + "." + std::to_string(monat) + 
      "." + std::to_string(jahr) + " ist ein ungueltiges Datum!";
    return meldung;
  }
};

constexpr bool istSchaltjahr(int jahr)
{
  return (jahr % 4 == 0 && jahr % 100) || jahr % 400 == 0;
}

constexpr bool istGueltigesDatum(int tag, int monat, int jahr)
{
  bool ergebnis = false;
  if ((monat >= 1 && monat <= 12) &&
      (jahr > 1582                     // 1582: Beginn des  gregorianischen Kalenders
       && jahr < 2400)                       // Plausibilitätskontrolle
  ) {
    int letzterTagImMonat = 29;              // nur Februar im Schaltjahr
    if (monat != 2 || !istSchaltjahr(jahr)) {  // sonst
      const int tageImMonat[]{31, 28, 31, 30, 31, 30, 
                                          31, 31, 30, 31, 30, 31};
      letzterTagImMonat = tageImMonat[monat - 1];
    }
    ergebnis = (tag >= 1 && tag <= letzterTagImMonat);
  }
  return ergebnis;
}

class Datum {
public:
  Datum();                                   // Standardkonstruktor

  constexpr Datum(int t, int m, int j)       // allgemeiner Konstruktor
      : tag_(t), monat_(m), jahr_(j)
  {
    if (!istGueltigesDatum(t, m, j)) {
      throw UngueltigesDatumException(t, m, j);
    }
  }
  constexpr auto tag() const   { return tag_; }
  constexpr auto monat() const { return monat_; }
  constexpr auto jahr() const  { return jahr_; }

  constexpr bool istSchaltjahr() const
  {
    return ::istSchaltjahr(jahr_);        // freie (globale) Funktion mit ::-Operator
  }
  void set(int t, int m, int j);             // Datum setzen
  void aktuell();                            // Systemdatum setzen
  Datum& operator++();                       // Tag hochzählen, präfix
  Datum operator++(int);                     // Tag hochzählen, postfix
  // alternativ: durch Methode toString() ersetzen (siehe Übungsaufgabe)
  explicit operator std::string() const;     // Typumwandlungsoperator
private:
  int tag_;
  int monat_;
  int jahr_;
};
#endif

