#include "Sinus.h"
#include <iostream>

template <typename Funktor>
void funktorErgebnisAnzeigen(double arg, const Funktor& funktor)
{
  std::cout << funktor(arg) << '\n';
}

int main()
{
  constexpr Sinus sinRad;
  constexpr Sinus sinGrad(Sinus::Modus::grad);

  // Aufruf der Objekte wie eine Funktion
  std::cout << "sin( pi/4 [rad])  = " << sinRad(std::numbers::pi / 4.0)
            << ". sin(45 Grad)    = " << sinGrad(45.0) << '\n';

  // direkter Aufruf von operator()(double)
  std::cout << "sin( pi/4 [rad])  = " 
            << sinRad.operator()(std::numbers::pi / 4.0)
            << ". sin(45 Grad)    = " << sinGrad.operator()(45.0) << '\n';

  // Übergabe eines Funktors an eine Funktion
  funktorErgebnisAnzeigen(45.0, sinGrad);
}

