#include <cassert>
#include <string>
#include <string_view>

int main()
{
  constexpr std::string_view anfuehrungszeichen{"\"\"\"\"\"\""};
  constexpr std::string_view roh_anfuehrungszeichen{R"("""""")"};
  static_assert(anfuehrungszeichen == roh_anfuehrungszeichen);

  std::string regex{"/\\*.*?\\*/"};
  std::string rawregex1{R"(/\*.*?\*/)"};
  assert(regex == rawregex1);

  std::string regexMitKlammern{"^\\D+([0-9]+) \\1"};
  std::string rawregexMitKlammern{R"=(^\D+([0-9]+) \1)="};
  assert(regexMitKlammern == rawregexMitKlammern);

  // Ein raw string kann über Zeilen gehen:
  std::string zeilen{"text\n\nneueZeile"};
  std::string roh_zeilen{R"(text

neueZeile)"};
  assert(zeilen == roh_zeilen);

  // Kombination mit U
  std::u32string u{U"\"UTF-32\""};
  std::u32string rawu{UR"("UTF-32")"};
  assert(u == rawu);
}
