// Zuweisung in einer Klassenhierarchie mit 3 Klassen.
// Jede Klasse hat einen  Zuweisungsoperator, damit kein
// Zuweisungsoperator implizit erzeugt wird, sowie eine Methode
// assign, die die eigentliche Arbeit erledigt.
// Move-Kopierkonstruktoren und Move-Zuweisung werden nicht berücksichtigt.
#include "C.h"          // schließt A.h, B.h ein
#include <cassert>
#include <iostream>
using namespace std;

#define CHECK(X)                                                      \
  cout << "CHECK " << (#X) << endl;                                                                \
  assert(X);

int main()
{
  int testnr = 0;
  // Klasse A
  cout << "\nTest " << ++testnr << "\n";
  A a1(1);
  A a2(2);
  a1.ausgabe();
  cout << '\n';
  a1 = a2;
  cout << "a1 nach Zuweisung a1=a2:\n";
  a1.ausgabe();
  cout << '\n';
  CHECK(a1 == a2)

  // Klasse B
  cout << "\nTest " << ++testnr << "\n";
  B b1(1, 2);
  B b2(3, 4);
  b1.ausgabe();
  cout << '\n';
  b1 = b2;
  cout << "b1 nach Zuweisung b1=b2:\n";
  b1.ausgabe();
  cout << '\n';
  CHECK(b1 == b2)

  cout << "\nTest " << ++testnr << " Referenz und Kopierkonstruktor A& ar(b1);  \n";
  A& ar(b1);          // Oberklassenreferenz
  CHECK(ar == b1)

  cout << "\nTest " << ++testnr << " polymorphe Zuweisung\n";
  B b3(5, 6);
  ar = b3;
  cout << "ar nach Zuweisung ar=b3:\n";
  ar.ausgabe();
  cout << '\n';
  CHECK(ar == b3)

  // Klasse C
  cout << "\nTest " << ++testnr << "\n";
  C c1(1, 2, 3);
  C c2(4, 5, 6);
  c1.ausgabe();
  cout << '\n';
  c1 = c2;
  cout << "c1 nach Zuweisung c1=c2:\n";
  c1.ausgabe();
  cout << '\n';
  CHECK(c1 == c2)

  cout << "\nTest " << ++testnr << " :  polymorphe Zuweisung A& = C\n";
  C c3(7, 8, 9);
  A& arc = c2;          // Oberklassenreferenz
  arc = c3;
  cout << "arc nach Zuweisung arc=c3:\n";
  arc.ausgabe();
  cout << '\n';
  CHECK(arc == c3)

  cout << "\nTest " << ++testnr << "  :  polymorphe Zuweisung B& = C\n";
  B& brc(c2);          // Oberklassenreferenz
  brc = c3;
  cout << "brc nach Zuweisung brc=c3:\n";
  brc.ausgabe();
  cout << '\n';
  CHECK(brc == c3)

  cout << "\nTest " << ++testnr << " :  falscher Typ: b1 = c3\n";
  try {
    b1 = c3;
  }
  catch (const bad_typeid& e) {
    cerr << "Falscher Typ! Exception: " << e.what() << '\n';
  }

  cout << "\nTest " << ++testnr << "  :  falscher Typ: a1 = c3\n";
  try {
    a1 = c3;
  }
  catch (const bad_typeid& e) {
    cerr << "Falscher Typ! Exception: " << e.what() << '\n';
  }

  cout << "Test-Ende\n";
}
